#include <gtk/gtk.h>

void 
on_button_cut_clicked (gpointer user_data, GtkButton *button) {
	GtkTextBuffer *buffer;
	
	g_assert (GTK_IS_TEXT_VIEW (user_data));

	g_print ("Cut clicked\n");
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));
	
	gtk_text_buffer_cut_clipboard (buffer, gtk_clipboard_get (GDK_NONE), TRUE);
}

void 
on_button_copy_clicked (gpointer user_data, GtkButton *button) {
	GtkTextBuffer *buffer;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));
	
	gtk_text_buffer_copy_clipboard (buffer, gtk_clipboard_get (GDK_NONE));
	g_print ("copy button\n");
}

void 
on_button_paste_clicked (gpointer user_data, GtkButton *button) {
	GtkTextBuffer *buffer;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_paste_clipboard (buffer, gtk_clipboard_get (GDK_NONE), NULL, TRUE);
}

void
on_button_clear_clicked (gpointer user_data, GtkButton *button) {
	GtkTextBuffer *buffer;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_delete_selection (buffer, TRUE, TRUE);
}

void
on_togglebutton_bold_toggled (gpointer user_data, GtkToggleButton *button) {
	GtkTextBuffer *buffer;
	GtkTextIter start, end;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_get_selection_bounds (buffer, &start, &end);

	if (gtk_toggle_button_get_active (button)) {
		gtk_text_buffer_apply_tag_by_name (buffer, "bold", &start, &end);
	} else {
		gtk_text_buffer_remove_tag_by_name (buffer, "bold", &start, &end);
	}
}

void
on_togglebutton_underline_toggled (gpointer user_data, GtkToggleButton *button) {
	GtkTextBuffer *buffer;
	GtkTextIter start, end;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_get_selection_bounds (buffer, &start, &end);

	if (gtk_toggle_button_get_active (button)) {
		gtk_text_buffer_apply_tag_by_name (buffer, "underline", &start, &end);
	} else {
		gtk_text_buffer_remove_tag_by_name (buffer, "underline", &start, &end);
	}
}

void
on_togglebutton_strike_toggled (gpointer user_data, GtkToggleButton *button) {
	GtkTextBuffer *buffer;
	GtkTextIter start, end;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_get_selection_bounds (buffer, &start, &end);

	if (gtk_toggle_button_get_active (button)) {
		gtk_text_buffer_apply_tag_by_name (buffer, "strike", &start, &end);
	} else {
		gtk_text_buffer_remove_tag_by_name (buffer, "strike", &start, &end);
	}
}

void
on_togglebutton_color_toggled (gpointer user_data, GtkToggleButton *button) {
	GtkTextBuffer *buffer;
	GtkTextIter start, end;
	
	g_return_if_fail (GTK_IS_TEXT_VIEW (user_data));
	
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (user_data));

	gtk_text_buffer_get_selection_bounds (buffer, &start, &end);

	if (gtk_toggle_button_get_active (button)) {
		gtk_text_buffer_apply_tag_by_name (buffer, "blue_foreground", &start, &end);
	} else {
		gtk_text_buffer_remove_tag_by_name (buffer, "blue_foreground", &start, &end);
	}
}
void
on_togglebutton_color_enter (gpointer user_data, GtkToggleButton *button) 
{
	GtkWidget *dialog;
	
	dialog = gtk_message_dialog_new (NULL,
		  GTK_DIALOG_DESTROY_WITH_PARENT,
		  GTK_MESSAGE_INFO,
		  GTK_BUTTONS_CLOSE,
		  "Mouse enter");
		  
	 gtk_dialog_run (GTK_DIALOG (dialog));

	 gtk_widget_destroy (dialog);
}
