#include <gtk/gtk.h>
#include <glade/glade.h>

static void create_tags (GtkTextView *textview);

int
main (int argc, char **argv) {
	GladeXML *xml;
	GtkWidget *window;
	GtkWidget *textview;

	gtk_init (&argc, &argv);
	
	xml = glade_xml_new ("dialogs/editor.glade", NULL, NULL);
	glade_xml_signal_autoconnect (xml);

	window = glade_xml_get_widget (xml, "main_window");
	textview = glade_xml_get_widget (xml, "textview");

	create_tags (GTK_TEXT_VIEW (textview));
	
	gtk_widget_show_all (window);
	
	gtk_main ();
	
	g_object_unref (G_OBJECT (xml));
	return 0;
}

static void 
create_tags (GtkTextView *textview) 
{
	GtkTextBuffer *buffer;

	g_assert (GTK_IS_TEXT_VIEW (textview));

	buffer = gtk_text_view_get_buffer (textview);

	gtk_text_buffer_create_tag (buffer, "bold",
		"weight", PANGO_WEIGHT_BOLD, NULL);

	gtk_text_buffer_create_tag (buffer, "underline",
		"underline", TRUE, NULL);

	gtk_text_buffer_create_tag (buffer, "strike",
		"strikethrough", TRUE, NULL);

	gtk_text_buffer_create_tag (buffer, "blue_foreground",
		"foreground", "blue", NULL);
}
