#include <glade/glade.h>
#include "callbacks.h"

void
on_cambiar_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *sw1, *sw2, *widget_in_sw1, *widget_in_sw2;
	GtkWidget *label;
	const gchar *type;

	sw1 = g_object_get_data (G_OBJECT (button), "sw1");
	sw2 = g_object_get_data (G_OBJECT (button), "sw2");
	label = g_object_get_data (G_OBJECT (button), "label");

	widget_in_sw1 = gtk_bin_get_child (GTK_BIN (sw1));
	widget_in_sw2 = gtk_bin_get_child (GTK_BIN (sw2));

	gtk_widget_ref (widget_in_sw1);
	gtk_widget_ref (widget_in_sw2);

	gtk_container_remove (GTK_CONTAINER (sw1), widget_in_sw1);
	gtk_container_remove (GTK_CONTAINER (sw2), widget_in_sw2);

	gtk_container_add (GTK_CONTAINER (sw2), widget_in_sw1);
	gtk_container_add (GTK_CONTAINER (sw1), widget_in_sw2);

	gtk_widget_unref (widget_in_sw1);
	gtk_widget_unref (widget_in_sw2);

	type = g_type_name (GTK_WIDGET_TYPE (widget_in_sw2));
	gtk_label_set_text (GTK_LABEL (label), type);
}

void
on_agregar_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *entry, *sw, *widget;
	const gchar *text;
	GType type;

	sw = g_object_get_data (G_OBJECT (button), "sw");
	entry = g_object_get_data (G_OBJECT (button), "entry");

	widget = gtk_bin_get_child (GTK_BIN (sw));
	text = gtk_entry_get_text (GTK_ENTRY (entry));
	type = GTK_WIDGET_TYPE (widget);

	if (g_type_is_a (type, g_type_from_name ("GtkTextView"))) {
		GtkTextBuffer *buffer;

		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (widget));
		gtk_text_buffer_insert_at_cursor (buffer, text, -1);
	} else {
		GtkCellRenderer *renderer;
		GtkTreeViewColumn *column;
		GtkTreeIter iter, sibling;
		GList *columns;
		GtkTreePath *path;
		GtkTreeModel *model;

		g_assert (g_type_is_a (type, g_type_from_name ("GtkTreeView")));

		columns =
		    gtk_tree_view_get_columns (GTK_TREE_VIEW (widget));

		if (g_list_length (columns) == 0) {
			renderer = gtk_cell_renderer_text_new ();
			column =
			    gtk_tree_view_column_new_with_attributes
			    ("Columns", renderer, "text", 0, NULL);
			gtk_tree_view_column_set_sort_column_id (column,
								 0);
			gtk_tree_view_append_column (GTK_TREE_VIEW
						     (widget), column);

			model = GTK_TREE_MODEL (gtk_list_store_new
					    (1, G_TYPE_STRING));

			gtk_tree_view_set_model (GTK_TREE_VIEW (widget),
						 model);
		}
		g_list_free (columns);

		model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
		gtk_tree_view_get_cursor (GTK_TREE_VIEW (widget), &path,
					  NULL);

		if (path != NULL) {
			gtk_tree_model_get_iter (model, &sibling, path);
			gtk_list_store_insert_after (GTK_LIST_STORE
							     (model),
							     &iter,
							     &sibling);
		} else {
			gtk_list_store_append (GTK_LIST_STORE (model),
					       &iter);
		}

		gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, text, -1);

		gtk_tree_view_set_model (GTK_TREE_VIEW (widget), model);
		path = gtk_tree_model_get_path (model, &iter);
		gtk_tree_view_set_cursor (GTK_TREE_VIEW (widget), path,
					  NULL, FALSE);

		gtk_tree_path_free (path);
	}
}
